<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (8)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="variables">Variables</h1>
    <p>
      Most of the time, a JavaScript application needs to work with information.
      Here are two examples:
    </p>
    <ol type="1">
      <li>
        An online shop – the information might include goods being sold and a
        shopping cart.
      </li>
      <li>
        A chat application – the information might include users, messages, and
        much more.
      </li>
    </ol>
    <p>Variables are used to store this information.</p>
    <h2 id="a-variable">A variable</h2>
    <p>
      A
      <a href="https://en.wikipedia.org/wiki/Variable_(computer_science)"
        >variable</a
      >
      is a “named storage” for data. We can use variables to store goodies,
      visitors, and other data.
    </p>
    <p>To create a variable in JavaScript, use the <code>let</code> keyword.</p>
    <p>
      The statement below creates (in other words: <em>declares</em>) a variable
      with the name “message”:
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> message<span class="op">;</span></a></code></pre>
    </div>
    <p>
      Now, we can put some data into it by using the assignment operator
      <code>=</code>:
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">let</span> message<span class="op">;</span></a>
<a class="sourceLine" id="cb2-2" title="2"></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="op">*!*</span></a>
<a class="sourceLine" id="cb2-4" title="4">message <span class="op">=</span> <span class="st">&#39;Hello&#39;</span><span class="op">;</span> <span class="co">// store the string</span></a>
<a class="sourceLine" id="cb2-5" title="5"><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span></a></code></pre>
    </div>
    <p>
      The string is now saved into the memory area associated with the variable.
      We can access it using the variable name:
    </p>
    <p>```js run let message; message = ‘Hello!’;</p>
    <p>
      <em>!</em> alert(message); // shows the variable content <em>/!</em> ```
    </p>
    <p>
      To be concise, we can combine the variable declaration and assignment into
      a single line:
    </p>
    <p>
      ```js run let message = “Hello!”; // define the variable and assign the
      value
    </p>
    <p>alert(message); // Hello! ```</p>
    <p>We can also declare multiple variables in one line:</p>
    <p>
      <code
        >js no-beautify let user = "John", age = 25, message = "Hello";</code
      >
    </p>
    <p>
      That might seem shorter, but we don’t recommend it. For the sake of better
      readability, please use a single line per variable.
    </p>
    <p>The multiline variant is a bit longer, but easier to read:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">let</span> user <span class="op">=</span> <span class="st">&quot;John&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="kw">let</span> age <span class="op">=</span> <span class="dv">25</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="kw">let</span> message <span class="op">=</span> <span class="st">&quot;Hello&quot;</span><span class="op">;</span></a></code></pre>
    </div>
    <p>Some people also define multiple variables in this multiline style:</p>
    <p>
      <code
        >js no-beautify let user = "John", age = 25, message = "Hello";</code
      >
    </p>
    <p>…Or even in the “comma-first” style:</p>
    <p>
      <code
        >js no-beautify let user = "John", age = 25, message = "Hello";</code
      >
    </p>
    <p>
      Technically, all these variants do the same thing. So, it’s a matter of
      personal taste and aesthetics.
    </p>
    <p>
      ```<code>smart header="</code>var<code>instead of</code>let<code
        >" In older scripts, you may also find another keyword:</code
      >var<code>instead of</code>let`:
    </p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="op">*!*</span><span class="kw">var</span><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span><span class="ss"> message = &#39;Hello&#39;;</span></a></code></pre>
    </div>
    <p>
      The <code>var</code> keyword is <em>almost</em> the same as
      <code>let</code>. It also declares a variable, but in a slightly
      different, “old-school” way.
    </p>
    <p>
      There are subtle differences between <code>let</code> and
      <code>var</code>, but they do not matter for us yet. We’ll cover them in
      detail in the chapter <a href="info:var" class="uri">info:var</a>.
    </p>
    <pre><code>
## A real-life analogy

We can easily grasp the concept of a &quot;variable&quot; if we imagine it as a &quot;box&quot; for data, with a uniquely-named sticker on it.

For instance, the variable `message` can be imagined as a box labeled `&quot;message&quot;` with the value `&quot;Hello!&quot;` in it:

![](variable.svg)

We can put any value in the box.

We can also change it as many times as we want:
```js run
let message;

message = &#39;Hello!&#39;;

message = &#39;World!&#39;; // value changed

alert(message);
```

When the value is changed, the old data is removed from the variable:

![](variable-change.svg)

We can also declare two variables and copy data from one into the other.

```js run
let hello = &#39;Hello world!&#39;;

let message;

*!*
// copy &#39;Hello world&#39; from hello into message
message = hello;
*/!*

// now two variables hold the same data
alert(hello); // Hello world!
alert(message); // Hello world!
```

````warn header=&quot;Declaring twice triggers an error&quot;
A variable should be declared only once.

A repeated declaration of the same variable is an error:

```js run
let message = &quot;This&quot;;

// repeated &#39;let&#39; leads to an error
let message = &quot;That&quot;; // SyntaxError: &#39;message&#39; has already been declared
```
So, we should declare a variable once and then refer to it without `let`.</code></pre>
    <p>
      ```smart header=“Functional languages” It’s interesting to note that there
      exist
      <a href="https://en.wikipedia.org/wiki/Functional_programming"
        >functional</a
      >
      programming languages, like
      <a href="http://www.scala-lang.org/">Scala</a> or
      <a href="http://www.erlang.org/">Erlang</a> that forbid changing variable
      values.
    </p>
    <p>
      In such languages, once the value is stored “in the box”, it’s there
      forever. If we need to store something else, the language forces us to
      create a new box (declare a new variable). We can’t reuse the old one.
    </p>
    <p>
      Though it may seem a little odd at first sight, these languages are quite
      capable of serious development. More than that, there are areas like
      parallel computations where this limitation confers certain benefits.
      Studying such a language (even if you’re not planning to use it soon) is
      recommended to broaden the mind. ```
    </p>
    <h2 id="variable-naming-variable-naming">
      Variable naming [#variable-naming]
    </h2>
    <p>There are two limitations on variable names in JavaScript:</p>
    <ol type="1">
      <li>
        The name must contain only letters, digits, or the symbols
        <code>$</code> and <code>_</code>.
      </li>
      <li>The first character must not be a digit.</li>
    </ol>
    <p>Examples of valid names:</p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">let</span> userName<span class="op">;</span></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="kw">let</span> test123<span class="op">;</span></a></code></pre>
    </div>
    <p>
      When the name contains multiple words,
      <a href="https://en.wikipedia.org/wiki/CamelCase">camelCase</a> is
      commonly used. That is: words go one after another, each word except first
      starting with a capital letter: <code>myVeryLongName</code>.
    </p>
    <p>
      What’s interesting – the dollar sign <code>'$'</code> and the underscore
      <code>'_'</code> can also be used in names. They are regular symbols, just
      like letters, without any special meaning.
    </p>
    <p>These names are valid:</p>
    <p>
      ```js run untrusted let $ = 1; // declared a variable with the name “$”
      let _ = 2; // and now a variable with the name "_"
    </p>
    <p>alert($ + _); // 3 ```</p>
    <p>Examples of incorrect variable names:</p>
    <p>```js no-beautify let 1a; // cannot start with a digit</p>
    <p>let my-name; // hyphens ‘-’ aren’t allowed in the name ```</p>
    <p>
      <code
        >smart header="Case matters" Variables named `apple` and `AppLE` are two
        different variables.</code
      >
    </p>
    <p>
      ````smart header=“Non-Latin letters are allowed, but not recommended” It
      is possible to use any language, including cyrillic letters or even
      hieroglyphs, like this:
    </p>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">let</span> имя <span class="op">=</span> <span class="st">&#39;...&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb7-2" title="2"><span class="kw">let</span> 我 <span class="op">=</span> <span class="st">&#39;...&#39;</span><span class="op">;</span></a></code></pre>
    </div>
    <p>
      Technically, there is no error here. Such names are allowed, but there is
      an international convention to use English in variable names. Even if
      we’re writing a small script, it may have a long life ahead. People from
      other countries may need to read it some time. ````
    </p>
    <p>
      ````warn header=“Reserved names” There is a
      <a
        href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Keywords"
        >list of reserved words</a
      >, which cannot be used as variable names because they are used by the
      language itself.
    </p>
    <p>
      For example: <code>let</code>, <code>class</code>, <code>return</code>,
      and <code>function</code> are reserved.
    </p>
    <p>The code below gives a syntax error:</p>
    <p>
      <code
        >js run no-beautify let let = 5; // can't name a variable "let", error!
        let return = 5; // also can't name it "return", error!</code
      >
      ````
    </p>
    <p>```<code>warn header="An assignment without</code>use strict`"</p>
    <p>
      Normally, we need to define a variable before using it. But in the old
      times, it was technically possible to create a variable by a mere
      assignment of the value without using <code>let</code>. This still works
      now if we don’t put <code>use strict</code> in our scripts to maintain
      compatibility with old scripts.
    </p>
    <p>```js run no-strict // note: no “use strict” in this example</p>
    <p>num = 5; // the variable “num” is created if it didn’t exist</p>
    <p>alert(num); // 5 ```</p>
    <p>This is a bad practice and would cause an error in strict mode:</p>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="st">&quot;use strict&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb8-2" title="2"></a>
<a class="sourceLine" id="cb8-3" title="3"><span class="op">*!*</span></a>
<a class="sourceLine" id="cb8-4" title="4">num <span class="op">=</span> <span class="dv">5</span><span class="op">;</span> <span class="co">// error: num is not defined</span></a>
<a class="sourceLine" id="cb8-5" title="5"><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span></a></code></pre>
    </div>
    <pre><code>
## Constants

To declare a constant (unchanging) variable, use `const` instead of `let`:

```js
const myBirthday = &#39;18.04.1982&#39;;
```

Variables declared using `const` are called &quot;constants&quot;. They cannot be reassigned. An attempt to do so would cause an error:

```js run
const myBirthday = &#39;18.04.1982&#39;;

myBirthday = &#39;01.01.2001&#39;; // error, can&#39;t reassign the constant!
```

When a programmer is sure that a variable will never change, they can declare it with `const` to guarantee and clearly communicate that fact to everyone.


### Uppercase constants

There is a widespread practice to use constants as aliases for difficult-to-remember values that are known prior to execution.

Such constants are named using capital letters and underscores.

For instance, let&#39;s make constants for colors in so-called &quot;web&quot; (hexadecimal) format:

```js run
const COLOR_RED = &quot;#F00&quot;;
const COLOR_GREEN = &quot;#0F0&quot;;
const COLOR_BLUE = &quot;#00F&quot;;
const COLOR_ORANGE = &quot;#FF7F00&quot;;

// ...when we need to pick a color
let color = COLOR_ORANGE;
alert(color); // #FF7F00
```

Benefits:

- `COLOR_ORANGE` is much easier to remember than `&quot;#FF7F00&quot;`.
- It is much easier to mistype `&quot;#FF7F00&quot;` than `COLOR_ORANGE`.
- When reading the code, `COLOR_ORANGE` is much more meaningful than `#FF7F00`.

When should we use capitals for a constant and when should we name it normally? Let&#39;s make that clear.

Being a &quot;constant&quot; just means that a variable&#39;s value never changes. But there are constants that are known prior to execution (like a hexadecimal value for red) and there are constants that are *calculated* in run-time, during the execution, but do not change after their initial assignment.

For instance:
```js
const pageLoadTime = /* time taken by a webpage to load */;
```

The value of `pageLoadTime` is not known prior to the page load, so it&#39;s named normally. But it&#39;s still a constant because it doesn&#39;t change after assignment.

In other words, capital-named constants are only used as aliases for &quot;hard-coded&quot; values.

## Name things right

Talking about variables, there&#39;s one more extremely important thing.

A variable name should have a clean, obvious meaning, describing the data that it stores.

Variable naming is one of the most important and complex skills in programming. A quick glance at variable names can reveal which code was written by a beginner versus an experienced developer.

In a real project, most of the time is spent modifying and extending an existing code base rather than writing something completely separate from scratch. When we return to some code after doing something else for a while, it&#39;s much easier to find information that is well-labeled. Or, in other words, when the variables have good names.

Please spend time thinking about the right name for a variable before declaring it. Doing so will repay you handsomely.

Some good-to-follow rules are:

- Use human-readable names like `userName` or `shoppingCart`.
- Stay away from abbreviations or short names like `a`, `b`, `c`, unless you really know what you&#39;re doing.
- Make names maximally descriptive and concise. Examples of bad names are `data` and `value`. Such names say nothing. It&#39;s only okay to use them if the context of the code makes it exceptionally obvious which data or value the variable is referencing.
- Agree on terms within your team and in your own mind. If a site visitor is called a &quot;user&quot; then we should name related variables `currentUser` or `newUser` instead of `currentVisitor` or `newManInTown`.

Sounds simple? Indeed it is, but creating descriptive and concise variable names in practice is not. Go for it.

```smart header=&quot;Reuse or create?&quot;
And the last note. There are some lazy programmers who, instead of declaring new variables, tend to reuse existing ones.

As a result, their variables are like boxes into which people throw different things without changing their stickers. What&#39;s inside the box now? Who knows? We need to come closer and check.

Such programmers save a little bit on variable declaration but lose ten times more on debugging.

An extra variable is good, not evil.

Modern JavaScript minifiers and browsers optimize code well enough, so it won&#39;t create performance issues. Using different variables for different values can even help the engine optimize your code.
```

## Summary

We can declare variables to store data by using the `var`, `let`, or `const` keywords.

- `let` -- is a modern variable declaration.
- `var` -- is an old-school variable declaration. Normally we don&#39;t use it at all, but we&#39;ll cover subtle differences from `let` in the chapter &lt;info:var&gt;, just in case you need them.
- `const` -- is like `let`, but the value of the variable can&#39;t be changed.

Variables should be named in a way that allows us to easily understand what&#39;s inside them.</code></pre>
  </body>
</html>
